"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var bull_1 = __importDefault(require("bull"));
var execa_1 = __importDefault(require("execa"));
var fastify_1 = __importDefault(require("fastify"));
var fs_extra_1 = __importDefault(require("fs-extra"));
var latest_version_1 = __importDefault(require("latest-version"));
var path_1 = __importDefault(require("path"));
var perf_hooks_1 = require("perf_hooks");
var request_promise_1 = __importDefault(require("request-promise"));
var utils_1 = require("./utils");
var REDIS_HOST = process.env.REDIS_HOST || 'localhost';
function buildQueue() {
    return __awaiter(this, void 0, void 0, function () {
        function statusRequest(webhook, data) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, request_promise_1.default({
                                method: 'POST',
                                uri: webhook.url,
                                body: {
                                    id: data.id,
                                    result: data.result,
                                    status: data.status,
                                    timestamp: perf_hooks_1.performance.now() + perf_hooks_1.performance.timeOrigin,
                                },
                                rejectUnauthorized: false,
                                json: true,
                                headers: webhook.headers,
                            })];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        }
        var queue;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    queue = new bull_1.default('nJinn', { redis: { host: REDIS_HOST } });
                    queue.process(100, function (job, done) {
                        return __awaiter(this, void 0, void 0, function () {
                            var _a, id, context, result, err_1;
                            return __generator(this, function (_b) {
                                switch (_b.label) {
                                    case 0:
                                        _b.trys.push([0, 2, , 3]);
                                        _a = job.data, id = _a.id, context = _a.context;
                                        return [4 /*yield*/, require(path_1.default.resolve("./generated/" + id))(context)];
                                    case 1:
                                        result = _b.sent();
                                        done(null, result);
                                        return [3 /*break*/, 3];
                                    case 2:
                                        err_1 = _b.sent();
                                        done(err_1);
                                        return [3 /*break*/, 3];
                                    case 3: return [2 /*return*/];
                                }
                            });
                        });
                    });
                    queue.on('completed', function (job, result) { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, statusRequest(job.data.webhook, __assign(__assign({}, job.data), { status: 'success', result: result }))];
                                case 1:
                                    _a.sent();
                                    return [2 /*return*/];
                            }
                        });
                    }); });
                    queue.on('failed', function (job, err) {
                        return __awaiter(this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, statusRequest(job.data.webhook, __assign(__assign({}, job.data), { status: 'fail' }))];
                                    case 1:
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            });
                        });
                    });
                    queue.on('active', function (job, jobPromise) {
                        return __awaiter(this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, statusRequest(job.data.webhook, __assign(__assign({}, job.data), { status: 'loading' }))];
                                    case 1:
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            });
                        });
                    });
                    return [4 /*yield*/, queue.isReady()];
                case 1:
                    _a.sent();
                    return [2 /*return*/, queue];
            }
        });
    });
}
function startServer(options) {
    return __awaiter(this, void 0, void 0, function () {
        function installPackages(packages) {
            if (packages === void 0) { packages = []; }
            return __awaiter(this, void 0, void 0, function () {
                var installedPackages, _loop_1, i;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, execa_1.default('npm', ['init', '-y'], { cwd: './generated' })];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, getPackages(packages.map(function (x) { return x.package; }))];
                        case 2:
                            installedPackages = _a.sent();
                            _loop_1 = function (i) {
                                var packageName, version, installedPackage, packageWithVersion, alreadyInstalled;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            packageName = packages[i].package;
                                            version = packages[i].version || 'latest';
                                            installedPackage = installedPackages.find(function (x) { return x.name === packageName; });
                                            packageWithVersion = packageName + "@" + version;
                                            alreadyInstalled = installedPackage && (installedPackage.installed === version || (version === 'latest' && installedPackage.installed === installedPackage.latest));
                                            if (!!alreadyInstalled) return [3 /*break*/, 2];
                                            return [4 /*yield*/, execa_1.default('npm', ['install', packageWithVersion], { cwd: './generated' })];
                                        case 1:
                                            _a.sent();
                                            _a.label = 2;
                                        case 2: return [2 /*return*/];
                                    }
                                });
                            };
                            i = 0;
                            _a.label = 3;
                        case 3:
                            if (!(i < packages.length)) return [3 /*break*/, 6];
                            return [5 /*yield**/, _loop_1(i)];
                        case 4:
                            _a.sent();
                            _a.label = 5;
                        case 5:
                            i++;
                            return [3 /*break*/, 3];
                        case 6: return [2 /*return*/];
                    }
                });
            });
        }
        function getPackages(packageNames) {
            if (packageNames === void 0) { packageNames = []; }
            return __awaiter(this, void 0, void 0, function () {
                var packages, installedPackages, i, packageName, latestPackageVersion;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, utils_1.getInstalledPackages('./generated')];
                        case 1:
                            packages = _a.sent();
                            installedPackages = [];
                            i = 0;
                            _a.label = 2;
                        case 2:
                            if (!(i < packageNames.length)) return [3 /*break*/, 5];
                            packageName = packageNames[i];
                            return [4 /*yield*/, latest_version_1.default(packageName)];
                        case 3:
                            latestPackageVersion = _a.sent();
                            if (packages[packageName]) {
                                installedPackages.push({
                                    name: packageName,
                                    installed: packages[packageName],
                                    latest: latestPackageVersion,
                                });
                            }
                            _a.label = 4;
                        case 4:
                            i++;
                            return [3 /*break*/, 2];
                        case 5: return [2 /*return*/, installedPackages];
                    }
                });
            });
        }
        var fastify, queue;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    fastify = fastify_1.default();
                    return [4 /*yield*/, buildQueue()];
                case 1:
                    queue = _a.sent();
                    fastify.post('/saveScript', function (request, reply) { return __awaiter(_this, void 0, void 0, function () {
                        var _a, script, id, fileName;
                        return __generator(this, function (_b) {
                            switch (_b.label) {
                                case 0:
                                    _a = request.body, script = _a.script, id = _a.id;
                                    if (!id) {
                                        throw new Error('id is required');
                                    }
                                    fileName = "./generated/" + id;
                                    return [4 /*yield*/, fs_extra_1.default.outputFile(fileName, script)];
                                case 1:
                                    _b.sent();
                                    delete require.cache[path_1.default.resolve(fileName)];
                                    reply.send();
                                    return [2 /*return*/];
                            }
                        });
                    }); });
                    fastify.post('/queueJobs', function (request, reply) {
                        var jobs = request.body;
                        if (jobs) {
                            jobs.forEach(function (job) {
                                queue.add(job, { removeOnComplete: true, removeOnFail: true, });
                            });
                        }
                        reply.send();
                    });
                    fastify.post('/executeScript', function (request, reply) { return __awaiter(_this, void 0, void 0, function () {
                        var _a, id, context, result;
                        return __generator(this, function (_b) {
                            switch (_b.label) {
                                case 0:
                                    _a = request.body, id = _a.id, context = _a.context;
                                    return [4 /*yield*/, require(path_1.default.resolve("./generated/" + id))(context)];
                                case 1:
                                    result = _b.sent();
                                    reply.send(result);
                                    return [2 /*return*/];
                            }
                        });
                    }); });
                    fastify.post('/installPackages', function (request, reply) { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, installPackages(request.body)];
                                case 1:
                                    _a.sent();
                                    reply.send();
                                    return [2 /*return*/];
                            }
                        });
                    }); });
                    fastify.addHook('onClose', function (instance, done) { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, queue.close()];
                                case 1:
                                    _a.sent();
                                    done();
                                    return [2 /*return*/];
                            }
                        });
                    }); });
                    return [4 /*yield*/, fastify.listen(options.port, '0.0.0.0')];
                case 2:
                    _a.sent();
                    console.log("Server started at http://localhost:" + options.port);
                    return [2 /*return*/, {
                            close: fastify.close,
                        }];
            }
        });
    });
}
exports.startServer = startServer;
